package cn.net.cpzslibs.prot.handset.newProt;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.bean.res.ProtStatusResBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20071ReqBean;

public class Prot20071SubmitTAInvoice extends ProtBase {

	private final short iTaskCode20071 = 20071;
	private Gson gson;
	private ProtStatusResBean resBean;
	
	public ProtStatusResBean getResponse(){
		return this.resBean;
	}

	public Prot20071SubmitTAInvoice() {
		gson = new Gson();
	}


	public void submitInvoice(SocketCreate create, Prot20071ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}

	private void recProt(Socket socket, DataOutputStream dos, DataInputStream dis, Prot20071ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode20071, "开始提交数据");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recDis(dis);
			}
		}
	}


	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20071,  "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20071, jsonData);
		resBean = gson.fromJson(jsonData, ProtStatusResBean.class);
		recCheckCode(dis);
		
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot20071ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		debugLog(iTaskCode20071, "发送的数据：" +bodyContent);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20071, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

}
